﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace QuantumEntanglement {
    public partial class Form1: Form {
        public Form1() {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e) {
            frmPhotonicSensor PS = new frmPhotonicSensor();
            PS.Show();
        }

        public Color Bad = Color.Salmon;
        public Color Good = Color.PaleGreen;

        public int getInteger(TextBox myT) {
            myT.BackColor=Bad;
            int rtn = System.Convert.ToInt32(myT.Text);
            myT.BackColor=Good;
            return rtn;
        }


        private void button2_Click(object sender, EventArgs e) {
            try {
                int numRuns = getInteger(tbNum);
                double leftAngle = (double)nudLeft.Value;
                double rightAngle = (double)nudRight.Value;
                double detThresh = (double)nudDetector.Value;
                QuantumEntanglement Q = new QuantumEntanglement();
                Q.Run(numRuns, leftAngle, rightAngle, detThresh);
                tbOutput.Text=Q.report();

            } catch(System.Exception ee) {
                tbOutput.Text=ee.Message+"\r\n"+ee.StackTrace;
            }
        }



        /// <summary>
        ///  this will do a brute force search to find optimal signal and detect threshold to obtain optimal outcomes for same and different 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bnOptimize_Click(object sender, EventArgs e) {
            tbOutput.Text="";

            int numRuns = 100000;
            double leftAngle = 0;

            double rightAngle = (double)nudRight.Value;
            double desiredSame=System.Math.Cos(rightAngle*System.Math.PI/180);
            desiredSame*=desiredSame;
            double desiredDiff=1-desiredSame;
            desiredSame*=100; // turn into percent 
            desiredDiff*=100; // turn into percent 


            QuantumEntanglement Q = new QuantumEntanglement();
            // this will do a brute force search to find optimal detector and singnal levels to obtain the best match for t
            int bestCC=0;
            double bestDist = 1e300;
            double bestSame=0;
            double bestDiff=0;
            int bestDetect=0;
            int bestSig=0;
            double MinDistance = 1e300;
            tbOutput.Text+="\r\n Dist, CC, Same, Diff, Thresh, signal";


            int min=100;
            int max=200;

            progressBar1.Minimum=min;
            progressBar1.Maximum=max-1;
            for(int detect = min; detect<max; detect++) {
                progressBar1.Value=detect;
                for(int sig=60; sig<120; sig++) {
                    Q.Clear();
                    Q.DetectorThrehsold=detect;
                    Q.SignalAmplitide=sig;
                    Q.Run(numRuns, leftAngle, rightAngle);
                    int CC = Q.CoincidentCount;
                    if(CC>0) {
                        double SS = desiredSame-Q.SamePcnt;
                        double DD = desiredDiff-Q.DiffPcnt;
                        double SquareDist = SS*SS+DD*DD;
                        MinDistance=System.Math.Min(MinDistance, SquareDist);
                        if(SquareDist<0.5) {
                            tbOutput.Text+="\r\n "+SquareDist.ToString("0.000")+", "+CC+", "+Q.SamePcnt.ToString("0.00")+", "+Q.DiffPcnt.ToString("0.00")+", "+detect+", "+sig;
                            if(CC>bestCC) {
                                bestDist=SquareDist;
                                bestCC=CC;
                                bestSame=Q.SamePcnt;
                                bestDiff=Q.DiffPcnt;
                                bestDetect=detect;
                                bestSig=sig;
                            }
                        }
                    }
                }
            }

            tbOutput.Text+="\r\n Dist="+bestDist.ToString("0.00"); 
            tbOutput.Text+="\r\n CC="+bestCC ;
            tbOutput.Text+="\r\n Same="+bestSame.ToString("0.0"); 
            tbOutput.Text+="\r\n Diff="+bestDiff.ToString("0.0"); 
            tbOutput.Text+="\r\n Thresh="+bestDetect.ToString("0.0");
            tbOutput.Text+="\r\n Signal="+bestSig.ToString("0.0");
            tbOutput.Text+="\r\n ";
            tbOutput.Text+="\r\n minDistance="+MinDistance.ToString("0.0"); 



        }//function 



        /// <summary>
        ///  this will do a brute force search to find optimal signal and detect threshold to obtain optimal outcomes for same and different 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bnOptimize2_Click(object sender, EventArgs e) {
            tbOutput.Text="";

            int numRuns = 1000000;
            double leftAngle = 0;
#if false
            double rightAngle = 0;
            double desiredSame=100;
            double desiredDiff=0;
#else
            double rightAngle = 22.5;
            double desiredSame=85;
            double desiredDiff=15;
#endif
            QuantumEntanglement Q = new QuantumEntanglement();
            // this will do a brute force search to find optimal detector and singnal levels to obtain the best match for t
            int bestCC=0;
            double bestDist = 1e300;
            double bestSame=0;
            double bestDiff=0;
            int bestDetect=0;
            int bestSig=0;

            tbOutput.Text+="\r\n Dist, CC, Same, Diff, Thresh, signal";


            int min=100;
            int max=200;
            int sigToDifDiff=67;

            progressBar1.Minimum=min;
            progressBar1.Maximum=max-1;
            for(int detect = min; detect<max; detect++) {
                progressBar1.Value=detect;
                int sig = detect-sigToDifDiff;
                //for(int sig=60; sig<120; sig++) {
                    Q.Clear();
                    Q.DetectorThrehsold=detect;
                    Q.SignalAmplitide=sig;
                    Q.Run(numRuns, leftAngle, rightAngle);
                    int CC = Q.CoincidentCount;
                    if(CC>0) {
                        double SS = desiredSame-Q.SamePcnt;
                        double DD = desiredDiff-Q.DiffPcnt;
                        double uncert=100/CC;
                        double SquareDist = SS*SS+DD*DD;
                        if(SquareDist<=0.01) {// within ?? percent 
                            tbOutput.Text+="\r\n "+SquareDist.ToString("0.000")+", "+CC+", "+Q.SamePcnt.ToString("0.00")+", "+Q.DiffPcnt.ToString("0.00")+", "+detect+", "+sig;
                            if(CC>bestCC) {
                                bestDist=SquareDist;
                                bestCC=CC;
                                bestSame=Q.SamePcnt;
                                bestDiff=Q.DiffPcnt;
                                bestDetect=detect;
                                bestSig=sig;
                            }
                        }
                    }
                //}
            }

            tbOutput.Text+="\r\n Dist="+bestDist.ToString("0.00");
            tbOutput.Text+="\r\n CC="+bestCC;
            tbOutput.Text+="\r\n Same="+bestSame.ToString("0.0");
            tbOutput.Text+="\r\n Diff="+bestDiff.ToString("0.0");
            tbOutput.Text+="\r\n Thresh="+bestDetect.ToString("0.0");
            tbOutput.Text+="\r\n Signal="+bestSig.ToString("0.0");



        }

        private void button3_Click(object sender, EventArgs e) {
            bnOptimize2_Click(sender, e);
        }//function 

    }//class
}//namespace 
